--[[ DISABLE ADDON IF CHAR ISN'T A PALADIN]]--
if select(2, UnitClass('player')) ~= "PALADIN" then
    DisableAddOn("QuiHolyPower")
    return
end

--[[ Add the foldername of style pack in the avalibleStyles table  ]]--
local avalibleStyles = { ["basic"] = true, ["basic-2"] = true }
--[[ Path to styles directory ]]--
local gfxPath = "Interface\\AddOns\\QuiHolyPower\\gfx\\";
--[[ File names of the style pack images ]]--
local hpGfx = { [0]="0.tga", [1]= "1.tga", [2]= "2.tga", [3]= "3.tga", [4]= "4.tga", [5]= "5.tga"}

local locked = true;
local barStyle = nil;
local hp_bar, events = CreateFrame("Frame", "QUIHP", UIParent ), {}
local tex = hp_bar:CreateTexture( )


function events:ADDON_LOADED()
	
	if( not options ) then
		hp_bar:SetPoint("CENTER", 0, 0 )
		hp_bar:SetScale( 1.4 )
		barStyle = "basic"
	else 
		barStyle = options.style
		hp_bar:SetPoint( options.point, options.xOffset, options.yOffset )
		hp_bar:SetScale( options.scale )
	end
	--gfxPath = "Interface\\AddOns\\QuiHolyPower\\gfx\\"..barStyle.."\\";
	hp_bar:SetWidth(128)
	hp_bar:SetHeight(128)
	hp_bar:SetAlpha(1)
	hp_bar:SetMovable()
	tex:SetTexture( gfxPath..barStyle.."\\0.tga" );
	tex:SetAllPoints(hp_bar)
	tex:SetAlpha(1)
	hp_bar:Show()
	hp_bar:SetUserPlaced(true)
end

function events:UNIT_POWER(source,type)
	hpGfx = { [0]="0.tga", [1]= "1.tga", [2]= "2.tga", [3]= "3.tga", [4]= "4.tga", [5]= "5.tga"}
	tex:SetTexture( gfxPath..barStyle.."\\"..hpGfx[ UnitPower("player",9 )] )
end

function events:PET_BATTLE_OPENING_START( source, type )
	hp_bar:Hide()
end
	
function events:PET_BATTLE_CLOSE( source, type )
	hp_bar:Show()
end	

function events:PLAYER_LOGOUT()
	local p, rt, rp, x, y = hp_bar:GetPoint(index)
	options = { 
				style = barStyle,
				scale = hp_bar:GetScale(),
				point = p, 
				xOffset = x,
				yOffset = y,
			}
end

hp_bar:SetScript("OnEvent",function(self,event,...) events[event](self,...) end)
for k,v in pairs(events) do
    hp_bar:RegisterEvent(k)
end


--[[ Command line options ]]--
SLASH_QUIHP1  = "/quihp";
SlashCmdList["QUIHP"] = function( cmd_line )
	local cmd, param = strsplit(" ", cmd_line, 2)
	if( cmd == "lock") then 
		hp_bar:toggleLock()
	elseif( cmd == "scale" ) then
		if( not param ) then
			DEFAULT_CHAT_FRAME:AddMessage( "QUI HolyPowerBar:")
			DEFAULT_CHAT_FRAME:AddMessage( " Scale is set to: "..hp_bar:GetScale() )
		else
			hp_bar:SetScale( param )
			DEFAULT_CHAT_FRAME:AddMessage( "QUI holyPowerBar:") 
			DEFAULT_CHAT_FRAME:AddMessage( " Scale set to: "..param )
		end
	elseif( cmd == "style" ) then
		if(  not param ) then 
			DEFAULT_CHAT_FRAME:AddMessage("QUI HolyPowerBar:" )
			DEFAULT_CHAT_FRAME:AddMessage(" Avalible Styles")
			for k,v in pairs( avalibleStyles ) do
				DEFAULT_CHAT_FRAME:AddMessage( "  "..k )
			end
		elseif(  param  ) then	
			if( avalibleStyles[ param ] ) then
				barStyle = param
				tex:SetTexture( gfxPath..barStyle.."\\"..hpGfx[ UnitPower("player",9 )] )
				DEFAULT_CHAT_FRAME:AddMessage( "QUI HolyPowerBar:")
				DEFAULT_CHAT_FRAME:AddMessage( " Style set to: "..param )
			else 
				DEFAULT_CHAT_FRAME:AddMessage( "QUI HolyPowerBar:")
				DEFAULT_CHAT_FRAME:AddMessage( " Style '"..param.."' is not avalible!" )
			end
		end
		
	else
		DEFAULT_CHAT_FRAME:AddMessage( "QUI HolyPowerBar:" )
		DEFAULT_CHAT_FRAME:AddMessage( "Commands:" )
		DEFAULT_CHAT_FRAME:AddMessage( "  /quihp lock   (To lock or unlock frame)" )
		DEFAULT_CHAT_FRAME:AddMessage( "  /quihp scale [<value>] (To set scale default value is 1.4)" )
		DEFAULT_CHAT_FRAME:AddMessage( "  /quihp style [<style>] (To set style default style is basic)" )
	end
end

function hp_bar:toggleLock()
	if locked then
		DEFAULT_CHAT_FRAME:AddMessage( 'QUI HolyPowerBar unlocked' )
		locked = false
		hp_bar:SetMovable(true)
		hp_bar:EnableMouse(true)
		hp_bar:RegisterForDrag("LeftButton")
		hp_bar:SetScript("OnDragStart", hp_bar.StartMoving)
		hp_bar:SetScript("OnDragStop", hp_bar.StopMovingOrSizing)
	else  
		locked = true
		hp_bar:EnableMouse(false)
		hp_bar:RegisterForDrag(nil)
		hp_bar:SetScript("OnDragStart", nil)
		hp_bar:SetScript("OnDragStop", nil)
		DEFAULT_CHAT_FRAME:AddMessage( 'QUI HolyPowerBar locked' )
	end
end



